diff --git a/web/regression/javascript/misc/statistics/statistics_spec.js b/web/regression/javascript/misc/statistics/statistics_spec.js
index 4fe2b1af3..79f5af52f 100644
--- a/web/regression/javascript/misc/statistics/statistics_spec.js
+++ b/web/regression/javascript/misc/statistics/statistics_spec.js
@@ -15,7 +15,7 @@ describe('#nodeHasStatistics', () => {
       const node = {
         hasStatistics: true,
       };
-      expect(nodeHasStatistics(node, {})).toEqual(true);
+      expect(nodeHasStatistics({}, node, {})).toEqual(true);
     });
   });
 
@@ -24,12 +24,16 @@ describe('#nodeHasStatistics', () => {
       it('returns true', () => {
         const node = {
           hasStatistics: () => true,
-          getTreeNodeHierarchy: jasmine.createSpy(),
+        };
+        const pgBrowser = {
+          tree: {
+            getTreeNodeHierarchy: jasmine.createSpy(),
+          }
         };
         const item = {};
 
-        expect(nodeHasStatistics(node, item)).toEqual(true);
-        expect(node.getTreeNodeHierarchy).toHaveBeenCalledWith(item);
+        expect(nodeHasStatistics(pgBrowser, node, item)).toEqual(true);
+        expect(pgBrowser.tree.getTreeNodeHierarchy).toHaveBeenCalledWith(item);
       });
     });
   });
diff --git a/web/regression/javascript/nodes/schema/child_menu_spec.js b/web/regression/javascript/nodes/schema/child_menu_spec.js
index 61acb01c3..23952f241 100644
--- a/web/regression/javascript/nodes/schema/child_menu_spec.js
+++ b/web/regression/javascript/nodes/schema/child_menu_spec.js
@@ -10,13 +10,14 @@
 import {
   isTreeItemOfChildOfSchema, childCreateMenuEnabled,
 } from 'pgadmin.schema.dir/schema_child_tree_node';
-
-import * as pgBrowser from 'pgbrowser/browser';
+import pgAdmin from 'sources/pgadmin';
 import {TreeFake} from '../../tree/tree_fake';
 
+
 describe('#childCreateMenuEnabled', () => {
-  let data;
-  let tree;
+  let data,
+    tree,
+    pgBrowser = pgAdmin.Browser;
 
   describe(' - when data is not null', () => {
     beforeEach(() => {
@@ -47,8 +48,8 @@ describe('#childCreateMenuEnabled', () => {
               }],
             };
 
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
+            tree = TreeFake.build(hierarchy, pgBrowser);
+            pgBrowser.tree = tree;
           });
           it(' it is true', () => {
             expect(childCreateMenuEnabled(
@@ -72,8 +73,8 @@ describe('#childCreateMenuEnabled', () => {
               }],
             };
 
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
+            tree = TreeFake.build(hierarchy, pgBrowser);
+            pgBrowser.tree = tree;
           });
 
           it(' it is true', () => {
@@ -101,8 +102,8 @@ describe('#childCreateMenuEnabled', () => {
               }],
             };
 
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
+            tree = TreeFake.build(hierarchy, pgBrowser);
+            pgBrowser.tree = tree;
           });
 
           it(' it is true', () => {
@@ -122,8 +123,8 @@ describe('#childCreateMenuEnabled', () => {
               }],
             };
 
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
+            tree = TreeFake.build(hierarchy, pgBrowser);
+            pgBrowser.tree = tree;
           });
           it(' it is false', () => {
             expect(
@@ -146,8 +147,8 @@ describe('#childCreateMenuEnabled', () => {
               }],
             };
 
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
+            tree = TreeFake.build(hierarchy, pgBrowser);
+            pgBrowser.tree = tree;
           });
 
           it(' it is false', () => {
@@ -175,8 +176,8 @@ describe('#childCreateMenuEnabled', () => {
               }],
             };
 
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
+            tree = TreeFake.build(hierarchy, pgBrowser);
+            pgBrowser.tree = tree;
           });
 
           it(' it is false', () => {
@@ -191,7 +192,9 @@ describe('#childCreateMenuEnabled', () => {
 });
 
 describe('#childDropMenuEnabled', () => {
-  let tree;
+  let tree,
+    pgBrowser = pgAdmin.Browser;
+
 
   describe(' - the child node under schema node ', () => {
     beforeEach(() => {
@@ -211,8 +214,8 @@ describe('#childDropMenuEnabled', () => {
         }],
       };
 
-      tree = TreeFake.build(hierarchy);
-      pgBrowser.treeMenu = tree;
+      tree = TreeFake.build(hierarchy, pgBrowser);
+      pgBrowser.tree = tree;
     });
 
     it(' it is true', () => {
@@ -240,8 +243,8 @@ describe('#childDropMenuEnabled', () => {
         }],
       };
 
-      tree = TreeFake.build(hierarchy);
-      pgBrowser.treeMenu = tree;
+      tree = TreeFake.build(hierarchy, pgBrowser);
+      pgBrowser.tree = tree;
     });
 
     it(' it is false', () => {
diff --git a/web/regression/javascript/restore/restore_dialog_spec.js b/web/regression/javascript/restore/restore_dialog_spec.js
index c77f3775a..a62dc82fa 100644
--- a/web/regression/javascript/restore/restore_dialog_spec.js
+++ b/web/regression/javascript/restore/restore_dialog_spec.js
@@ -22,7 +22,7 @@ describe('RestoreDialog', () => {
 
   beforeEach(() => {
     pgBrowser = {
-      treeMenu: new TreeFake(),
+      tree: new TreeFake(),
       Nodes: {
         server: jasmine.createSpyObj('Node[server]', ['getTreeNodeHierarchy']),
         database: jasmine.createSpyObj('Node[database]', ['getTreeNodeHierarchy']),
@@ -113,7 +113,7 @@ describe('RestoreDialog', () => {
       ],
     };
 
-    pgBrowser.treeMenu = TreeFake.build(hierarchy);
+    pgBrowser.tree = TreeFake.build(hierarchy, pgBrowser);
   });
 
   describe('#draw', () => {
@@ -138,7 +138,7 @@ describe('RestoreDialog', () => {
 
     context('there are no ancestors of the type server', () => {
       it('does not create a dialog', () => {
-        pgBrowser.treeMenu.selectNode([{id: 'root'}]);
+        pgBrowser.tree.selectNode([{id: 'root'}]);
         restoreDialog.draw(null, null, null);
         expect(alertifySpy['pg_restore']).not.toHaveBeenCalled();
       });
diff --git a/web/regression/javascript/restore/restore_dialog_wrapper_spec.js b/web/regression/javascript/restore/restore_dialog_wrapper_spec.js
index a328bb5be..cde9b145c 100644
--- a/web/regression/javascript/restore/restore_dialog_wrapper_spec.js
+++ b/web/regression/javascript/restore/restore_dialog_wrapper_spec.js
@@ -11,7 +11,7 @@ import {RestoreDialogWrapper} from '../../../pgadmin/tools/restore/static/js/res
 import MockAdapter from 'axios-mock-adapter';
 import axios from 'axios/index';
 import {FakeModel} from '../fake_model';
-import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree_nodes';
 
 let context = describe;
 
@@ -32,7 +32,6 @@ describe('RestoreDialogWrapper', () => {
 
   beforeEach(() => {
     pgBrowser = {
-      treeMenu: new TreeFake(),
       Nodes: {
         server: {
           hasId: true,
@@ -41,9 +40,10 @@ describe('RestoreDialogWrapper', () => {
       },
       keyboardNavigation: jasmine.createSpyObj('keyboardNavigation', ['getDialogTabNavigator']),
     };
+    pgBrowser.tree = new TreeFake(pgBrowser);
 
-    noDataNode = pgBrowser.treeMenu.addNewNode('level1.1', undefined, [{id: 'level1'}]);
-    serverTreeNode = pgBrowser.treeMenu.addNewNode('level2.1', {
+    noDataNode = pgBrowser.tree.addNewNode('level1.1', undefined, [{id: 'level1'}]);
+    serverTreeNode = pgBrowser.tree.addNewNode('level2.1', {
       _type: 'server',
       _id: 10,
       label: 'some-tree-label',
@@ -123,7 +123,7 @@ describe('RestoreDialogWrapper', () => {
 
     context('selected tree node has no data', () => {
       beforeEach(() => {
-        pgBrowser.treeMenu.selectNode(noDataNode.domNode);
+        pgBrowser.tree.selectNode(noDataNode.domNode);
       });
 
       it('does not create a backform dialog', () => {
@@ -149,7 +149,7 @@ describe('RestoreDialogWrapper', () => {
             label: 'some-tree-label',
           },
         };
-        pgBrowser.treeMenu.selectNode(serverTreeNode.domNode);
+        pgBrowser.tree.selectNode(serverTreeNode.domNode);
         pgBrowser.Nodes['server'].getTreeNodeHierarchy.and
           .returnValue(treeHierarchyInformation);
         dialogSpy = jasmine.createSpyObj('newView', ['render']);
@@ -226,7 +226,7 @@ describe('RestoreDialogWrapper', () => {
       let networkCalled;
       beforeEach(() => {
         networkCalled = false;
-        pgBrowser.treeMenu.selectNode(serverTreeNode.domNode);
+        pgBrowser.tree.selectNode(serverTreeNode.domNode);
         networkMock.onAny(/.+/).reply(() => {
           networkCalled = true;
           return [200, {}];
@@ -267,7 +267,7 @@ describe('RestoreDialogWrapper', () => {
       let networkCalled;
       beforeEach(() => {
         networkCalled = false;
-        pgBrowser.treeMenu.selectNode(serverTreeNode.domNode);
+        pgBrowser.tree.selectNode(serverTreeNode.domNode);
         networkMock.onAny(/.+/).reply(() => {
           networkCalled = true;
           return [200, {}];
@@ -350,7 +350,7 @@ describe('RestoreDialogWrapper', () => {
               },
             },
           };
-          pgBrowser.treeMenu.selectNode(noDataNode.domNode);
+          pgBrowser.tree.selectNode(noDataNode.domNode);
         });
 
         it('does not start the restore', () => {
@@ -364,12 +364,12 @@ describe('RestoreDialogWrapper', () => {
         let databaseTreeNode;
 
         beforeEach(() => {
-          databaseTreeNode = pgBrowser.treeMenu.addNewNode('level3.1', {
+          databaseTreeNode = pgBrowser.tree.addNewNode('level3.1', {
             _type: 'database',
             _id: 10,
             _label: 'some-database-label',
           }, [{id: 'level3.1'}]);
-          pgBrowser.treeMenu.addChild(serverTreeNode, databaseTreeNode);
+          pgBrowser.tree.addChild(serverTreeNode, databaseTreeNode);
           pgBrowser.Nodes.database = {
             hasId: true,
             _label: 'some-database-label',
@@ -379,7 +379,7 @@ describe('RestoreDialogWrapper', () => {
           restoreDialogWrapper.view = {
             model: fakeModel,
           };
-          pgBrowser.treeMenu.selectNode(databaseTreeNode.domNode);
+          pgBrowser.tree.selectNode(databaseTreeNode.domNode);
           pgBrowser.Events = jasmine.createSpyObj('pgBrowserEventsSpy', ['trigger']);
           event = {
             button: {
diff --git a/web/regression/javascript/search_objects/search_objects_dialog_spec.js b/web/regression/javascript/search_objects/search_objects_dialog_spec.js
index 465d4152c..eec5ddb0a 100644
--- a/web/regression/javascript/search_objects/search_objects_dialog_spec.js
+++ b/web/regression/javascript/search_objects/search_objects_dialog_spec.js
@@ -32,7 +32,6 @@ describe('SearchObjectsDialog', () => {
 
   beforeEach(() => {
     pgBrowser.preferences_cache = dummy_cache;
-    pgBrowser.treeMenu  = new TreeFake();
     pgBrowser.Nodes  = {
       server: {
         hasId: true,
@@ -50,7 +49,7 @@ describe('SearchObjectsDialog', () => {
         getTreeNodeHierarchy: jasmine.createSpy('db.getTreeNodeHierarchy'),
       },
     };
-
+    pgBrowser.tree  = new TreeFake(pgBrowser);
     pgBrowser.stdW = {
       sm: 500,
       md: 700,
@@ -108,7 +107,7 @@ describe('SearchObjectsDialog', () => {
       ],
     };
 
-    pgBrowser.treeMenu = TreeFake.build(hierarchy);
+    pgBrowser.tree = TreeFake.build(hierarchy, pgBrowser);
   });
 
   describe('#draw', () => {
@@ -137,7 +136,7 @@ describe('SearchObjectsDialog', () => {
 
     context('there are no ancestors of the type database', () => {
       it('does not create a dialog', () => {
-        pgBrowser.treeMenu.selectNode([{id: 'serverTreeNode'}]);
+        pgBrowser.tree.selectNode([{id: 'serverTreeNode'}]);
         soDialog.draw(null, null, null);
         expect(alertifySpy['search_objects']).not.toHaveBeenCalled();
       });
diff --git a/web/regression/javascript/search_objects/search_objects_dialog_wrapper_spec.js b/web/regression/javascript/search_objects/search_objects_dialog_wrapper_spec.js
index 9681b4671..ae0e7be35 100644
--- a/web/regression/javascript/search_objects/search_objects_dialog_wrapper_spec.js
+++ b/web/regression/javascript/search_objects/search_objects_dialog_wrapper_spec.js
@@ -11,7 +11,7 @@ import {TreeFake} from '../tree/tree_fake';
 import SearchObjectsDialogWrapper from 'tools/search_objects/static/js/search_objects_dialog_wrapper';
 import axios from 'axios/index';
 import MockAdapter from 'axios-mock-adapter';
-import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree_nodes';
 
 let context = describe;
 
@@ -32,7 +32,6 @@ describe('SearchObjectsDialogWrapper', () => {
 
   beforeEach(() => {
     pgBrowser = {
-      treeMenu: new TreeFake(),
       Nodes: {
         server: {
           hasId: true,
@@ -74,8 +73,9 @@ describe('SearchObjectsDialogWrapper', () => {
       },
       keyboardNavigation: jasmine.createSpyObj('keyboardNavigation', ['getDialogTabNavigator']),
     };
-    noDataNode = pgBrowser.treeMenu.addNewNode('level1.1', undefined, [{id: 'level1'}]);
-    serverTreeNode = pgBrowser.treeMenu.addNewNode('level2.1', {
+    pgBrowser.tree =  new TreeFake(pgBrowser),
+    noDataNode = pgBrowser.tree.addNewNode('level1.1', undefined, [{id: 'level1'}]);
+    serverTreeNode = pgBrowser.tree.addNewNode('level2.1', {
       _type: 'server',
       _id: 10,
       label: 'some-tree-label',
@@ -85,7 +85,7 @@ describe('SearchObjectsDialogWrapper', () => {
       _id: 123,
       _label: 'some-database-label',
     }, [{id: 'database-tree-node'}]);
-    pgBrowser.treeMenu.addChild(serverTreeNode, databaseTreeNode);
+    pgBrowser.tree.addChild(serverTreeNode, databaseTreeNode);
 
     jquerySpy = jasmine.createSpy('jquerySpy');
     soNode = {
@@ -153,7 +153,7 @@ describe('SearchObjectsDialogWrapper', () => {
 
     context('selected tree node has no data', () => {
       beforeEach(() => {
-        pgBrowser.treeMenu.selectNode(noDataNode.domNode);
+        pgBrowser.tree.selectNode(noDataNode.domNode);
       });
 
       it('does not prepare the dialog', () => {
@@ -168,7 +168,7 @@ describe('SearchObjectsDialogWrapper', () => {
       let networkMock;
 
       beforeEach(() => {
-        pgBrowser.treeMenu.selectNode(databaseTreeNode.domNode);
+        pgBrowser.tree.selectNode(databaseTreeNode.domNode);
         soDialogWrapper.grid = jasmine.createSpyObj('grid', ['destroy']);
         spyOn(soDialogWrapper, 'showMessage');
         gridDestroySpy = spyOn(soDialogWrapper.grid, 'destroy');
@@ -503,9 +503,9 @@ describe('SearchObjectsDialogWrapper', () => {
         };
 
         soDialogWrapper.treeInfo = {
-          'server_group': {'id': 'server_group/1', '_id': 1},
-          'server': {'id': 'server/3', '_id': 3},
-          'database': {'id': 'database/18456', '_id': 18456},
+          'server_group': {'id': 'server_group_1', '_id': 1},
+          'server': {'id': 'server_3', '_id': 3},
+          'database': {'id': 'database_18456', '_id': 18456},
         };
       });
       it('regular schema', ()=>{
@@ -515,7 +515,7 @@ describe('SearchObjectsDialogWrapper', () => {
         let retVal = soDialogWrapper.translateSearchObjectsPath(path, catalog_level);
         expect(retVal).toEqual([
           'Schemas/test_db/Tables/sampletab',
-          ['server_group/1','server/3','coll-database/3','database/18456','coll-schema/18456','schema/2200','coll-table/2200','table/2604'],
+          ['server_group_1','server_3','coll-database_3','database_18456','coll-schema_18456','schema_2200','coll-table_2200','table_2604'],
         ]);
       });
 
@@ -527,7 +527,7 @@ describe('SearchObjectsDialogWrapper', () => {
           let retVal = soDialogWrapper.translateSearchObjectsPath(path, catalog_level);
           expect(retVal).toEqual([
             'Catalogs/PostgreSQL Catalog (pg_catalog)/Tables/pg_class',
-            ['server_group/1','server/3','coll-database/3','database/18456','coll-catalog/18456','catalog/11','coll-table/11','table/2604'],
+            ['server_group_1','server_3','coll-database_3','database_18456','coll-catalog_18456','catalog_11','coll-table_11','table_2604'],
           ]);
         });
 
@@ -538,7 +538,7 @@ describe('SearchObjectsDialogWrapper', () => {
           let retVal = soDialogWrapper.translateSearchObjectsPath(path, catalog_level);
           expect(retVal).toEqual([
             'Catalogs/ANSI (information_schema)/Catalog Objects/attributes',
-            ['server_group/1','server/3','coll-database/3','database/18456','coll-catalog/18456','catalog/11','coll-catalog_object/11','catalog_object/2604'],
+            ['server_group_1','server_3','coll-database_3','database_18456','coll-catalog_18456','catalog_11','coll-catalog_object_11','catalog_object_2604'],
           ]);
         });
       });
diff --git a/web/regression/javascript/table/enable_disable_triggers_spec.js b/web/regression/javascript/table/enable_disable_triggers_spec.js
index 8b4694ee5..ff8906ba8 100644
--- a/web/regression/javascript/table/enable_disable_triggers_spec.js
+++ b/web/regression/javascript/table/enable_disable_triggers_spec.js
@@ -14,7 +14,7 @@ import {
   disableTriggers,
 } from '../../../pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/enable_disable_triggers';
 import {TreeFake} from '../tree/tree_fake';
-import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree_nodes';
 
 describe('#enableTriggers', () => {
   let networkMock;
@@ -24,6 +24,13 @@ describe('#enableTriggers', () => {
   beforeEach(() => {
     networkMock = new MockAdapter(axios);
     tree = new TreeFake();
+
+    spyOn(tree, 'unload').and.callFake(function() {
+      return new Promise((resolve)=>{
+        resolve('Success!');
+      });
+    });
+
     const server1 = tree.addNewNode('server1', {_id: 1}, ['<li>server1</li>']);
     const database1 = tree.addNewNode('database1', {_type: 'database'}, ['<li>database1</li>']);
     tree.addChild(server1, database1);
@@ -100,7 +107,7 @@ describe('#enableTriggers', () => {
           setTimeout(() => {
             expect(tree.selected()).toEqual(['<li>table1</li>']);
             done();
-          }, 20);
+          }, 30);
         });
 
         it('call backend with the correct parameters', (done) => {
@@ -171,6 +178,12 @@ describe('#disableTriggers', () => {
     alertify = jasmine.createSpyObj('alertify', ['success', 'error']);
     generateUrlSpy = jasmine.createSpy('generateUrl');
     generateUrlSpy.and.returnValue('/some/place');
+    spyOn(tree, 'unload').and.callFake(function() {
+      return new Promise((resolve)=>{
+        resolve('Success!');
+      });
+    });
+
   });
 
   describe('no node is selected', () => {
diff --git a/web/regression/javascript/tree/pgadmin_tree_state_save_spec.js b/web/regression/javascript/tree/pgadmin_tree_state_save_spec.js
index 6e902768b..e89ef91d1 100644
--- a/web/regression/javascript/tree/pgadmin_tree_state_save_spec.js
+++ b/web/regression/javascript/tree/pgadmin_tree_state_save_spec.js
@@ -107,7 +107,10 @@ describe('#browserTreeState', () => {
         };},
       },
     };
-    pgBrowser.tree = jasmine.createSpyObj('tree', ['itemData', 'pathId', 'hasParent', 'isOpen', 'isClosed', 'selected']);
+    pgBrowser.tree = jasmine.createSpyObj('tree', ['itemData', 'pathId', 'hasParent', 'isOpen', 'isClosed', 'selected', 'parent']);
+    pgBrowser.tree.getTreeNodeHierarchy = function (item) {
+      return pgBrowser.Nodes[item._type].getTreeNodeHierarchy();
+    };
   });
 
   describe('When node is opened tree state is getting updated', () => {
diff --git a/web/regression/javascript/tree/tree_fake.js b/web/regression/javascript/tree/tree_fake.js
index fe647504f..337594f52 100644
--- a/web/regression/javascript/tree/tree_fake.js
+++ b/web/regression/javascript/tree/tree_fake.js
@@ -8,10 +8,11 @@
 //////////////////////////////////////////////////////////////
 
 import {Tree} from '../../../pgadmin/static/js/tree/tree';
+import {ManageTreeNodes, TreeNode} from '../../../pgadmin/static/js/tree/tree_nodes';
 
 export class TreeFake extends Tree {
-  static build(structure) {
-    let tree = new TreeFake();
+  static build(structure, pgBrowser) {
+    let tree = new TreeFake(pgBrowser);
     let rootNode = tree.rootNode;
 
     if (structure.children !== undefined) {
@@ -27,7 +28,10 @@ export class TreeFake extends Tree {
     let id = newNode.id;
     let data = newNode.data ? newNode.data : {};
     let domNode = newNode.domNode ? newNode.domNode : [{id: id}];
-    tree.addNewNode(id, data, domNode, tree.translateTreeNodeIdFromACITree([parent]));
+
+    let parentPath = tree.translateTreeNodeIdFromReactTree([parent]);
+
+    tree.addNewNode(id, data, domNode, parentPath);
 
     if (newNode.children !== undefined) {
       newNode.children.forEach((child) => {
@@ -36,50 +40,96 @@ export class TreeFake extends Tree {
     }
   }
 
-  constructor() {
-    super();
-    this.aciTreeToOurTreeTranslator = {};
-    this.aciTreeApi = jasmine.createSpyObj(
-      'ACITreeApi', ['setInode', 'unload', 'deselect', 'select']);
-    this.aciTreeApi.unload.and.callFake(function(domNode, config) {
+  constructor(pgBrowser) {
+    let manageTree = new ManageTreeNodes();
+    let tree = jasmine.createSpyObj(
+      'tree', ['unload', 'onTreeEvents',
+        'getActiveFile', 'setActiveFile',
+        'deSelectActiveFile', 'closeDirectory']);
+    tree.unload.and.callFake(function(domNode, config) {
       config.success();
     });
+
+    super(tree, manageTree, pgBrowser);
+    this.aciTreeToOurTreeTranslator = {};
+
   }
 
   addNewNode(id, data, domNode, path) {
-    this.aciTreeToOurTreeTranslator[id] = [id];
+    this.aciTreeToOurTreeTranslator[id] = id;
     if (path !== null && path !== undefined) {
-      this.aciTreeToOurTreeTranslator[id] = path.concat(id);
+      if (typeof(path) === 'object') path = path.join('/');
+      this.aciTreeToOurTreeTranslator[id] = path != '' ? path + '/' + id : id;
+      if (path.indexOf('/browser/') != 0) path = path != '' ? '/browser/' + path : undefined;
     }
     return super.addNewNode(id, data, domNode, path);
   }
 
   addChild(parent, child) {
     child.setParent(parent);
-    this.aciTreeToOurTreeTranslator[child.id] = this.aciTreeToOurTreeTranslator[parent.id].concat(child.id);
+    this.aciTreeToOurTreeTranslator[child.id] = this.aciTreeToOurTreeTranslator[parent.id] + '/' + child.id;
     parent.children.push(child);
   }
 
   hasParent(aciTreeNode) {
-    return this.translateTreeNodeIdFromACITree(aciTreeNode).length > 1;
+    let parents = this.translateTreeNodeIdFromReactTree(aciTreeNode).split('/');
+    return parents.length > 1;
   }
 
   parent(aciTreeNode) {
     if (this.hasParent(aciTreeNode)) {
-      let path = this.translateTreeNodeIdFromACITree(aciTreeNode);
-      return [{id: this.findNode(path).parent().id}];
+      let path = this.translateTreeNodeIdFromReactTree(aciTreeNode);
+      return [{id: this.findNode('/browser/' + path).parent().id}];
     }
 
     return null;
   }
 
-  translateTreeNodeIdFromACITree(aciTreeNode) {
+  translateTreeNodeIdFromReactTree(aciTreeNode) {
     if (aciTreeNode === undefined || aciTreeNode[0] === undefined) {
       return null;
     }
     return this.aciTreeToOurTreeTranslator[aciTreeNode[0].id];
   }
 
+  findNodeByDomElement(domElement) {
+    const path = this.translateTreeNodeIdFromReactTree(domElement);
+
+    if(!path || !path[0]) {
+      return undefined;
+    }
+
+    return this.findNode('/browser/' + path);
+
+  }
+
+  getTreeNodeHierarchy(identifier) {
+    let idx = 0;
+    let node_cnt = 0;
+    let result = {};
+    let item = TreeNode.prototype.isPrototypeOf(identifier) ? identifier :
+      (identifier.path ? this.findNode(identifier.path) : this.findNodeByDomElement(identifier));
+
+    if (item == undefined || item == null) return null;
+
+    do {
+      const currentNodeData = item.getData();
+      if (currentNodeData._type in this.Nodes && this.Nodes[currentNodeData._type].hasId) {
+        const nodeType = mapType(currentNodeData._type, node_cnt);
+        if (result[nodeType] === undefined) {
+          result[nodeType] = _.extend({}, currentNodeData, {
+            'priority': idx,
+          });
+          idx -= 1;
+        }
+      }
+      node_cnt += 1;
+      item = item.hasParent() ? item.parent() : null;
+    } while (item);
+
+    return result;
+  }
+
   itemData(aciTreeNode) {
     let node = this.findNodeByDomElement(aciTreeNode);
     if (node === undefined || node === null) {
@@ -96,3 +146,7 @@ export class TreeFake extends Tree {
     this.selectedNode = selectedNode;
   }
 }
+
+function mapType(type, idx) {
+  return (type === 'partition' && idx > 0) ? 'table' : type;
+}
